

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public final class ProcessUtil {

	public static List<XProcess> getRunningProcess() {
		List<XProcess> runningProcess = new ArrayList<XProcess>();
		try {
			String cmd = System.getenv("windir") + "\\system32\\" + "tasklist /fo csv /nh /V";
			Process p;
			p = Runtime.getRuntime().exec(cmd);
			InputStreamReader isr = new InputStreamReader(p.getInputStream());
			BufferedReader input = new BufferedReader(isr);
			String line = "";
			while ((line = input.readLine()) != null) {
				XProcess process = parseProcess(line);
				if (process != null) {
					runningProcess.add(process);
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		return runningProcess;
	}

	private static XProcess parseProcess(final String cmd) {
		XProcess process = null;
		String line = cmd.replaceAll("\"", "");
		String[] prc = line.split(",");
		if (prc.length == 9) {
			String abbildname = prc[0];
			String pid = prc[1];
			String sitzungsname = prc[2];
			String sitzungsnummer = prc[3];
			String speichernutzung = prc[4];
			String status = prc[5];
			String benutzername = prc[6];
			String cpuzeit = prc[7];
			String fenstertitel = prc[8];
			process = new XProcess(abbildname, pid, sitzungsname, sitzungsnummer, speichernutzung, status, benutzername, cpuzeit, fenstertitel);
		}
		return process;
	}
}
